#include <sandbox.h>

#include <iostream>
#include <sstream>

#include <socketstream/resolver.h>
#include <socketstream/address.h>
#include <socketstream/iostream.h>

#include "asynch_resolver.h"

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

int main (int, char const*[])
{
	try
	{
		ss::asynch_resolver resolver;
		resolver.flags(AI_CANONNAME);
		resolver.resolve("www.mndfck.org", "http");

		// Do stuff that takes time.

		ss::resolver_result const& result = resolver.result();

		ss::ipv4_address address;
		for (ss::resolver_result::const_iterator i = result.begin();
			i != result.end(); ++i) {
 				if (i->ai_family == AF_INET) {
 					address = *i->ai_addr;
 					break;
 				}
		}

		sockaddr_in* sin = reinterpret_cast<sockaddr_in*>(&address);
		std::cout << ::inet_ntoa(sin->sin_addr) << std::endl;		
	}
	catch (std::exception const& e)
	{
		std::cout << e.what() << std::endl;
	}

	return 0;
}
