// -*- Socket Streams -*-

// Copyright (C) 2003, 2004, 2005 Pedro Lamarão <pedro.lamarao@mndfck.org>

// This file is part of the Socket Streams Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU Lesser General Public License as published by the
// Free Software Foundation; either version 2.1 of the License
// or (at your option) any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License along
// with this library; see the file COPYING. If not, write to the Free
// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
// USA

/** @file iostream.h
 * @brief User-friendly access to socketstream classes.
 * 
 * This header includes the isocketstream, osocketstream, and socketream classes.
 */

/** @defgroup iostream I/O Streams
 * @brief The I/O streams implementation.
 * 
 * These classes implement the std::basic_istream and std::basic_ostream
 * interfaces of the standard library. They build over
 * socketstream::basic_socketbuf.
 */

#ifndef SOCKETSTREAM_IOSTREAM_H
#define SOCKETSTREAM_IOSTREAM_H 1

#include <socketstream/basic_isocketstream.h>
#include <socketstream/basic_osocketstream.h>
#include <socketstream/basic_iosocketstream.h>

#endif // SOCKETSTREAM_IOSTREAM_H

