// -*- Socket Streams -*-

// Copyright (C) 2003, 2004, 2005 Pedro Lamarão <pedro.lamarao@mndfck.org>

// This file is part of the Socket Streams Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU Lesser General Public License as published by the
// Free Software Foundation; either version 2.1 of the License
// or (at your option) any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License along
// with this library; see the file COPYING. If not, write to the Free
// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
// USA

/** @file listener.h
 * @brief User-friendly access to the listener class.
 * 
 * This header includes the listener class.
 */

/** @defgroup listener Network Listener
 * @brief The network listener class.
 * 
 * Features of the listener class:
 * 
 * - bind method works with @ref address module
 * - accept method works with @ref iostream module
 * 
 * Using the listener class:
 * 
 * @code
 * extern sockaddr_in address;
 * listener l(sockets_base::ipv4);
 * l.bind(address);
 * @endcode 
 */

#ifndef SOCKETSTREAM_LISTENER_H
#define SOCKETSTREAM_LISTENER_H 1

#include <socketstream/basic_socketstream_listener.h>

#endif // SOCKETSTREAM_LISTENER_H

