// -*- Socket Streams -*-

// Copyright (C) 2003, 2004, 2005 Pedro Lamarão <pedro.lamarao@mndfck.org>

// This file is part of the Socket Streams Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU Lesser General Public License as published by the
// Free Software Foundation; either version 2.1 of the License
// or (at your option) any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License along
// with this library; see the file COPYING. If not, write to the Free
// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
// USA

/** @file socketbuf.h
 * @brief User-friendly access to basic_socketbut template class.
 */

/** @defgroup socketbuf Socket Buffer
 * @brief The socket buffer class.
 * 
 * The socket buffer class is an implementation of the
 * std::basic_streambuf class.
 * 
 * It's purpose is to buffer output and input to/from a socket. The current
 * implementation maintains a buffer for input and a buffer for output, with no
 * putback space.
 * 
 * This class is used by the iostream implementation, and should not be used
 * directly.
 * 
 */

#ifndef SOCKETSTREAM_SOCKETBUF_H
#define SOCKETSTREAM_SOCKETBUF_H 1

#ifdef WIN32
# include <socketstream/win32.h>
#endif

#include <socketstream/basic_socketbuf.h>

#endif // SOCKETSTREAM_SOCKETBUF_H

