// -*- Socket Streams -*-

// Copyright (C) 2003, 2004, 2005 Pedro Lamarão <pedro.lamarao@mndfck.org>

// This file is part of the Socket Streams Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU Lesser General Public License as published by the
// Free Software Foundation; either version 2.1 of the License
// or (at your option) any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License along
// with this library; see the file COPYING. If not, write to the Free
// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
// USA

/** @file address_exception.cc
 * @doctodo
 */

#include <socketstream/address_exception.h>

#ifdef WIN32
# include <winsock2.h>
# include <ws2tcpip.h>
#else
# include <netdb.h>
#endif

namespace ss {

  resolver_exception::resolver_exception(int __code) throw ()
  : _M_msg(), _M_code(__code)
  {
    _M_msg = ::gai_strerror(__code);
  }

  const char*
  resolver_exception::what () const throw ()
  {
    return _M_msg.c_str();
  }

  int
  resolver_exception::code () const throw ()
  {
    return _M_code;
  }

}

